import { ComponentFixture, TestBed } from '@angular/core/testing';
import { ActivatedRoute } from '@angular/router';
import { of } from 'rxjs';

import { GitsearchTestModule } from '../../../test.module';
import { WatchListEntryDetailComponent } from 'app/entities/watch-list-entry/watch-list-entry-detail.component';
import { WatchListEntry } from 'app/shared/model/watch-list-entry.model';

describe('Component Tests', () => {
  describe('WatchListEntry Management Detail Component', () => {
    let comp: WatchListEntryDetailComponent;
    let fixture: ComponentFixture<WatchListEntryDetailComponent>;
    const route = ({ data: of({ watchListEntry: new WatchListEntry(123) }) } as any) as ActivatedRoute;

    beforeEach(() => {
      TestBed.configureTestingModule({
        imports: [GitsearchTestModule],
        declarations: [WatchListEntryDetailComponent],
        providers: [{ provide: ActivatedRoute, useValue: route }],
      })
        .overrideTemplate(WatchListEntryDetailComponent, '')
        .compileComponents();
      fixture = TestBed.createComponent(WatchListEntryDetailComponent);
      comp = fixture.componentInstance;
    });

    describe('OnInit', () => {
      it('Should load watchListEntry on init', () => {
        // WHEN
        comp.ngOnInit();

        // THEN
        expect(comp.watchListEntry).toEqual(jasmine.objectContaining({ id: 123 }));
      });
    });
  });
});
